' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : D.Yamaguchi
'
'  : 2007/02/28 
' -----------------------------------------------------------------

Imports System.Windows.Forms.DialogResult
Imports System.IO
Imports FVDATASLib
Imports Microsoft

Public Class frmMain

    'rfIfoCXI[vĂ邩
    Private m_blnVideoOpened As Boolean

    'IꂽrfIݒt@C̃tpX
    Private m_strVideoConfFilePath As String

    'ƃfBNg
    Private m_strDirectory As String

    'GbWo͈
    Private m_EdgeScanBox As New FvRectangle

    'SW
    Private m_intCenterX As Integer
    Private m_intCenterY As Integer

    Private m_intVLineNum As Integer   'o
    Private m_intHLineNum As Integer   'o
    Private m_intVPitch As Integer     'osb`
    Private m_intHPitch As Integer     'osb`

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim intErr As Integer
        Dim frmVideoConf As New frmSelectVideoConfFile
        Dim frmLicence As New frmLicence

        'Rg[̐ݒ
        cmbColor.Items.Add("")
        cmbColor.Items.Add("")
        cmbColor.Items.Add("w")
        cmbColor.SelectedIndex = 2

        m_blnVideoOpened = False
        btnGrab.Enabled = False

        'ƃfBNgޔ
        m_strDirectory = Directory.GetCurrentDirectory()

        'gp̊mF
        If frmLicence.ShowDialog() = Yes Then
            'rfIݒt@C̑I
            m_strVideoConfFilePath = ""
            If frmVideoConf.ShowDialog() = OK Then
                m_strVideoConfFilePath = frmVideoConf.strVideoConfFilePath
            End If

            If m_strVideoConfFilePath.Length <> 0 Then
                'rfIݒt@CR|[lgɐݒ
                AxFvxVideo1.VideoConfFile = m_strVideoConfFilePath

                'Lv`{[h̃I[v
                Try
                    AxFvxVideo1.OpenDevice()
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("Lv`{[h̃I[vɎs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'VideoConfFile̕ύXOpenDevicesƃgK[h̕ύX܂B
                '̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
                '{vOł͊ȗ̂߂Ɉꗥ350ms̃ZbgAbv^CmۂĂ܂A
                'ۂ̃vOł͂g̃Lv`{[hɍ킹ĕύXĂB
                Threading.Thread.Sleep(350)

                'GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
                '炩ChangeImageSize\bhɂImagẽTCYύXĂĂB
                'i荞݃TCYImagẽTCYႤꍇ̓G[ɂȂ܂j
                AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

                Try
                    '捞
                    AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("rfI̎捞Ɏs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'Lv`{[h̏Ԃۑ
                m_blnVideoOpened = True
                btnGrab.Enabled = True
            End If
        Else
            'uӂ܂vIꂽꍇ̓TvvOI
            End
        End If

        'ʂ̐
        AxFvxDisplayEx1.CreateDisplay()
        '摜\
        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

        'GbWo͈͂̏lݒ
        m_EdgeScanBox.xs = 60
        m_EdgeScanBox.ys = 160
        m_EdgeScanBox.xe = 480
        m_EdgeScanBox.ye = 310
        m_intCenterX = (m_EdgeScanBox.xs + m_EdgeScanBox.xe) / 2
        m_intCenterY = (m_EdgeScanBox.ys + m_EdgeScanBox.ye) / 2

        'o̕\
        ApplyChanges()
        DrawScanLines()

    End Sub

    'EBhETCYύXꂽƂ̏
    Private Sub frmMain_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize

        If Me.WindowState = 0 Or Me.WindowState = 2 Then
            Dim newSize As New Size
            newSize.Width = Me.Width - AxFvxDisplayEx1.Left - 20
            newSize.Height = Me.Height - AxFvxDisplayEx1.Top - 55
            AxFvxDisplayEx1.Size = newSize
        End If

    End Sub

    Private Sub frmMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed

        If m_blnVideoOpened = True Then
            'Lv`{[hI[vĂꍇ̓N[Y
            AxFvxVideo1.CloseDevice()
        End If

    End Sub

    '摜荞
    Private Sub btnGrab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrab.Click

        '摜t@Cǂݍ݂ɂĉ摜TCY
        'ύXĂ\邽߁AChangeImageSizesĂ܂B
        '摜TCYύX\ꍇ́AɈxsΖ肠܂B
        AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

        Try
            '捞
            AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
        Catch ex As System.Exception
            Dim intErr As Integer
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox("rfI̎捞Ɏs܂ErrCode=" + intErr.ToString(), vbExclamation, "G[")
        End Try

        '摜\
        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    '摜t@CǍ
    Private Sub btnLoadImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadImage.Click

        '_CAOɂĉ摜t@CI
        OpenFileDialog1.InitialDirectory = m_strDirectory
        OpenFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        OpenFileDialog1.DefaultExt = "*.bmp"
        OpenFileDialog1.ShowDialog()

        If OpenFileDialog1.FileName.Length > 0 Then

            'FvxFileAccesspăt@CFvxImageɉ摜Ǎ
            AxFvxFileAccess1.FilePath = OpenFileDialog1.FileName

            Try
                AxFvxFileAccess1.LoadBitmap(AxFvxImage1.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("Ǎ݂Ɏs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ǂݍݎs")
                Exit Sub
            End Try

            '摜^Cv`FbN
            If AxFvxImage1.BitPerPixel <> 8 Or AxFvxImage1.ImageType <> FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray Then

                MsgBox("8bitOC̉摜ł͂܂", , "error")
                AxFvxImage1.BitPerPixel = 8
                AxFvxImage1.ImageType = FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray
                AxFvxImage1.ImageWidth = 512
                AxFvxImage1.ImageHeight = 480
            End If

            '摜\
            AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
        End If

    End Sub

    '摜t@Cۑ
    Private Sub btnSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImage.Click

        SaveFileDialog1.InitialDirectory = m_strDirectory
        SaveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        SaveFileDialog1.DefaultExt = "*.bmp"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length > 0 Then
            'FvxFileAccesspFvxImaget@Cɕۑ
            AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName()

            Try
                AxFvxFileAccess1.SaveBitmap(AxFvxImage1.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("ۑɎs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ۑs")
                Exit Sub
            End Try
        End If

    End Sub

    '}EX̃{^ꂽƂ̏
    Private Sub AxFvxDisplayEx1_MouseDownEvent(ByVal sender As System.Object, ByVal e As AxFVXCOMDISPLAYEXLib._IFvxDisplayExEvents_MouseDownEvent) Handles AxFvxDisplayEx1.MouseDownEvent

        If e.button = 1 Then
            'oQ̒Sړ
            MoveCenter(e.x, e.y)
        End If

    End Sub

    '}EXړꂽƂ̏
    Private Sub AxFvxDisplayEx1_MouseMoveEvent(ByVal sender As System.Object, ByVal e As AxFVXCOMDISPLAYEXLib._IFvxDisplayExEvents_MouseMoveEvent) Handles AxFvxDisplayEx1.MouseMoveEvent

        If e.button = 1 Then
            'oQ̒Sړ
            MoveCenter(e.x, e.y)
        End If

    End Sub

    'oQ̒Sړ
    Private Sub MoveCenter(ByVal X As Integer, ByVal Y As Integer)

        'NbsO
        If X < m_EdgeScanBox.xs Then X = m_EdgeScanBox.xs
        If Y < m_EdgeScanBox.ys Then Y = m_EdgeScanBox.ys
        If m_EdgeScanBox.xe < X Then X = m_EdgeScanBox.xe
        If m_EdgeScanBox.ye < Y Then Y = m_EdgeScanBox.ye

        m_intCenterX = X
        m_intCenterY = Y

        'oĕ`
        AxFvxDisplayEx1.ClearOverlay()
        DrawScanLines()
        'My.Application.DoEvents()

    End Sub

    'XV(p[^Kp)
    Private Sub btnApplyChanges_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnApplyChanges.Click

        AxFvxDisplayEx1.ClearOverlay()
        If ApplyChanges = 0 Then
            DrawScanLines()
        End If

    End Sub

    '͈͂̐ݒ
    Private Sub btnSetScanWnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetScanWnd.Click

        Dim intOK As Integer
        Dim pPoint As New FvPoint
        Dim dblTemp As Double

        '݂̒llƂēKp
        AxFvxROI1.SetRectangle(m_EdgeScanBox)

        'FvxROIgď͈͑I_CAO\
        AxFvxROI1.UsePoint = False
        AxFvxROI1.UseRectangle = True

        AxFvxROI1.MakeROIDialog(AxFvxImage1.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI1.CheckRectangle = 1 Then
            AxFvxROI1.GetRectangle(m_EdgeScanBox)

            'n_ƏI_tɂȂĂȂǂ`FbN܂
            'FvxROIŋ`f[^ꍇAƉE̍WʒutɂȂĂꍇ(xs > xe, ys > ye)ł
            'ւɂ̂܂܌ʂԂ܂̂łӂB
            If m_EdgeScanBox.xe < m_EdgeScanBox.xs Then
                dblTemp = m_EdgeScanBox.xs
                m_EdgeScanBox.xs = m_EdgeScanBox.xe
                m_EdgeScanBox.xe = dblTemp
            End If
            If m_EdgeScanBox.ye < m_EdgeScanBox.ys Then
                dblTemp = m_EdgeScanBox.ys
                m_EdgeScanBox.ys = m_EdgeScanBox.ye
                m_EdgeScanBox.ye = dblTemp
            End If
        End If

        'öʒuړ܂
        m_intCenterX = (m_EdgeScanBox.xs + m_EdgeScanBox.xe) / 2
        m_intCenterY = (m_EdgeScanBox.ys + m_EdgeScanBox.ye) / 2

        AxFvxDisplayEx1.ClearOverlay()
        DrawScanLines()

    End Sub

    'GbWos
    'SA㉺Eꂼ̕ɑ΂ČoA
    'OɌđAGbW_߂܂
    Private Sub btnExecute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExecute.Click

        Dim pEdgeScanLine As New FvLineSegment  'GbWo
        Dim pEdgeResult As New FvEdgeResult     'GbWo

        Dim dblTime As Double '
        Dim intCount As Integer  'GbW
        Dim intErr As Integer    'G[ԍ

        Dim i As Integer
        Dim intLoop As Integer


        'ʏ
        AxFvxDisplayEx1.ClearOverlay()

        'p[^Kp
        If 0 <> ApplyChanges Then Exit Sub

        'GbW_͐ŕ\
        AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)

        'ԌvJn
        AxFvxPerformanceCounter1.StartCount()

        Try
            '
            pEdgeScanLine.xs = m_intCenterX
            intLoop = Convert.ToInt32(m_intHLineNum / 2)
            For i = -intLoop To intLoop

                pEdgeScanLine.xe = m_EdgeScanBox.xe
                pEdgeScanLine.ys = m_intCenterY + m_intHPitch * i
                pEdgeScanLine.ye = pEdgeScanLine.ys

                '͈͂Ɏ܂Ă邩ǂ`FbN
                If m_EdgeScanBox.ys <= pEdgeScanLine.ys And pEdgeScanLine.ys <= m_EdgeScanBox.ye Then

                    'GbWos
                    AxFvxEdge1.Execute(AxFvxImage1.GetOcx(), pEdgeScanLine, intCount)

                    If intCount >= 1 Then
                        AxFvxEdge1.GetResult(0, pEdgeResult) 'oGbW͂P_݂̂Ȃ̂ŁAIndexNo0
                        AxFvxDisplayEx1.DrawData(0, pEdgeResult)
                    End If

                    'Ώ̂ȔΑ
                    pEdgeScanLine.xe = m_EdgeScanBox.xs

                    'GbWos
                    AxFvxEdge1.Execute(AxFvxImage1.GetOcx(), pEdgeScanLine, intCount)

                    If intCount >= 1 Then
                        AxFvxEdge1.GetResult(0, pEdgeResult)
                        AxFvxDisplayEx1.DrawData(0, pEdgeResult)
                    End If
                End If
            Next

            '
            pEdgeScanLine.ys = m_intCenterY
            intLoop = Convert.ToInt32(m_intVLineNum / 2)
            For i = -intLoop To intLoop

                pEdgeScanLine.xs = m_intCenterX + m_intVPitch * i
                pEdgeScanLine.xe = pEdgeScanLine.xs
                pEdgeScanLine.ye = m_EdgeScanBox.ye

                '͈͂Ɏ܂Ă邩H
                If m_EdgeScanBox.xs <= pEdgeScanLine.xs And pEdgeScanLine.xs <= m_EdgeScanBox.xe Then

                    'GbWos
                    AxFvxEdge1.Execute(AxFvxImage1.GetOcx(), pEdgeScanLine, intCount)

                    If intCount >= 1 Then
                        AxFvxEdge1.GetResult(0, pEdgeResult)
                        AxFvxDisplayEx1.DrawData(0, pEdgeResult)
                    End If

                    'Ώ̂ȔΑ
                    pEdgeScanLine.ye = m_EdgeScanBox.ys

                    'GbWos
                    AxFvxEdge1.Execute(AxFvxImage1.GetOcx(), pEdgeScanLine, intCount)

                    If intCount >= 1 Then
                        AxFvxEdge1.GetResult(0, pEdgeResult)
                        AxFvxDisplayEx1.DrawData(0, pEdgeResult)
                    End If
                End If
            Next

            'ԌvI
            AxFvxPerformanceCounter1.StopCount(dblTime)

            txtInfo.Text = VisualBasic.Format(dblTime, "0.##ms")
        Catch ex As Exception
            AxFvxEdge1.GetErrReport(intErr)
            If intErr <> 0 Then
                MsgBox(GetEdgeErrMesg(intErr), vbExclamation, "G[")
            Else
                MsgBox(Err.Number & " : " & Err.Description, vbExclamation, "G[")
            End If
        End Try

    End Sub

    'GbWo̕`
    '㉺Eꂼ̌o4Fŕ\܂
    Private Sub DrawScanLines()

        Dim pEdgeScanLine As New FvLineSegment  'GbWo
        Dim i As Integer, j As Integer

        '͈
        AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(128, 128, 128)
        AxFvxDisplayEx1.DrawData(0, m_EdgeScanBox)

        '
        pEdgeScanLine.xs = m_intCenterX
        j = Convert.ToInt32(m_intHLineNum / 2)
        For i = -j To j
            pEdgeScanLine.ys = m_intCenterY + m_intHPitch * i
            pEdgeScanLine.ye = pEdgeScanLine.ys

            '͈͂Ɏ܂Ă邩ǂ`FbN
            If m_EdgeScanBox.ys <= pEdgeScanLine.ys And pEdgeScanLine.ys <= m_EdgeScanBox.ye Then

                pEdgeScanLine.xe = m_EdgeScanBox.xe
                AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(128, 255, 128)
                AxFvxDisplayEx1.DrawData(0, pEdgeScanLine)

                pEdgeScanLine.xe = m_EdgeScanBox.xs
                AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(255, 128, 128)
                AxFvxDisplayEx1.DrawData(0, pEdgeScanLine)
            End If
        Next

        'c
        pEdgeScanLine.ys = m_intCenterY
        j = Convert.ToInt32(m_intVLineNum / 2)
        For i = -j To j
            pEdgeScanLine.xs = m_intCenterX + m_intVPitch * i
            pEdgeScanLine.xe = pEdgeScanLine.xs

            '͈͂Ɏ܂Ă邩ǂ`FbN
            If m_EdgeScanBox.xs <= pEdgeScanLine.xs And pEdgeScanLine.xs <= m_EdgeScanBox.xe Then
                pEdgeScanLine.ye = m_EdgeScanBox.ye
                AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(255, 255, 128)
                AxFvxDisplayEx1.DrawData(0, pEdgeScanLine)

                pEdgeScanLine.ye = m_EdgeScanBox.ys
                AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(128, 255, 255)
                AxFvxDisplayEx1.DrawData(0, pEdgeScanLine)
            End If
        Next

    End Sub

    'eRg[ɓ͂ꂽp[^̓Kp
    Private Function ApplyChanges() As Integer

        Dim intTemp As Integer
        Dim intErr As Integer
        Dim strErrMesg As String = ""

        intErr = 0

        'o{
        If Integer.TryParse(txtHLineNum.Text, intTemp) = False Or intTemp < 0 Then
            strErrMesg = "{0ȏ̊͂Ă" & vbCrLf
            intErr = -1
        ElseIf (intTemp Mod 2 = 0) Then
            intTemp = intTemp + 1
            txtHLineNum.Text = intTemp
        Else
            m_intHLineNum = intTemp
        End If

        'co{
        If Integer.TryParse(txtVLineNum.Text, intTemp) = False Or intTemp < 0 Then
            strErrMesg = "c{0ȏ̊͂Ă" & vbCrLf
            intErr = -1
        ElseIf (intTemp Mod 2 = 0) Then
            intTemp = intTemp + 1
            txtVLineNum.Text = intTemp
        Else
            m_intVLineNum = intTemp
        End If

        'sb`
        If Integer.TryParse(txtHPitch.Text, intTemp) = False Or intTemp < 1 Then
            strErrMesg = "sb`1ȏ̐͂Ă" & vbCrLf
            intErr = -1
        Else
            m_intHPitch = intTemp
        End If

        'csb`
        If Integer.TryParse(txtVPitch.Text, intTemp) = False Or intTemp < 1 Then
            strErrMesg = "csb`1ȏ̐͂Ă" & vbCrLf
            intErr = -1
        Else
            m_intVPitch = intTemp
        End If

        '臒l
        If Integer.TryParse(txtThreshold.Text, intTemp) = False Or intTemp < 0 Or intTemp > 200 Then
            MsgBox("臒l 0`200 ̊ԂŐݒ肵Ă", vbExclamation, "G[")
            intErr = -1
        Else
            AxFvxEdge1.Thresh = intTemp
        End If

        'Е
        If Integer.TryParse(txtLineWidth.Text, intTemp) = False Or intTemp < 0 Then
            MsgBox("Е0ȏŐݒ肵Ă", vbExclamation, "G[")
            intErr = -1
        Else
            AxFvxEdge1.LineWidth = intTemp
        End If

        Select Case cmbColor.SelectedIndex
            Case 0  '
                AxFvxEdge1.EdgeColor = FVXCOMEDGELib.EDGE_COLOR_TYPE.BLACK_TO_WHITE
            Case 1  '
                AxFvxEdge1.EdgeColor = FVXCOMEDGELib.EDGE_COLOR_TYPE.WHITE_TO_BLACK
            Case 2  'w
                AxFvxEdge1.EdgeColor = FVXCOMEDGELib.EDGE_COLOR_TYPE.ALL_COLOR
        End Select

        If intErr <> 0 Then
            MsgBox(strErrMesg, vbExclamation, "G[")
        End If

        ApplyChanges = intErr

    End Function

    Public Function GetEdgeErrMesg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 0
                GetEdgeErrMesg = "G["
            Case 4005
                GetEdgeErrMesg = "p[^Ⴂ܂"
            Case 4006
                GetEdgeErrMesg = "̌^Ⴂ܂"
            Case 4007
                GetEdgeErrMesg = "NULLw肳Ă܂"
            Case 4013
                GetEdgeErrMesg = "̈悪w肳Ă܂"
            Case Else
                GetEdgeErrMesg = "sȃG[łB"
        End Select

    End Function

    Private Sub txtThreshold_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtVPitch.KeyPress, txtVLineNum.KeyPress, txtThreshold.KeyPress, txtLineWidth.KeyPress, txtHPitch.KeyPress, txtHLineNum.KeyPress

        'l̂ݓ͂ł悤ɐ
        If ("0"c <= e.KeyChar And e.KeyChar <= "9"c) Or (e.KeyChar = Chr(&H8)) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub
End Class
